package j3d_uebung;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.media.j3d.Appearance;
import java.awt.Color;
import j3d_uebung.geometry.Book;
/**
 *
 * @author  arnd
 */
public class BookFrame extends javax.swing.JFrame {
    private Canvas3D canvas;

    public BookFrame() {
        initComponents();
        
        //Komponente fr Rendering erzeugen (Zeichenflche)
        java.awt.GraphicsConfiguration config =
        SimpleUniverse.getPreferredConfiguration();
        canvas = new Canvas3D(config);
        
        //Komponente zum Layout hinzufgen
        getContentPane().add(canvas);
        
        //Inhaltszweig erzeugen
        BranchGroup scene = createSceneGraph();
        
        //Szene kompilieren
        scene.compile();
        
        //Simple Universe erzeugen
        SimpleUniverse simpleU = new SimpleUniverse(canvas);
        
        // ViewPlatform fr Betrachtung der Objekte in der Szene
        // zurcksetzen
        simpleU.getViewingPlatform().setNominalViewingTransform();
        
        //Inhaltszweig zum Szenengraphen hinzufgen
        simpleU.addBranchGraph(scene);        
    }
    
    //Inhaltszweig des Szenegraphen erzeugen
    public BranchGroup createSceneGraph() {
        // Wurzel des Szenengrafes erzeugen
        BranchGroup objRoot = new BranchGroup();
        
        // Rotationsobjekt erzeugen
        Transform3D rotate = new Transform3D();
        
        //Rotieren um -90 Grad um X-Achse (nach "vorne")
        rotate.rotX(-Math.PI/4.0d);
        
        //fr Perspektive 
        TransformGroup objRotate = new TransformGroup(rotate);
        
        //an Wurzelknoten hngen
        objRoot.addChild(objRotate);
        
        //"Buch" erzeugen
        Group book = Book.createBook(canvas);
        
        //Buch an Rotationsgruppe hngen
        objRotate.addChild(book);

        //neues Standard-Punktlicht erzeugen
        PointLight light1 = new PointLight();
        
        //Postition Licht auf 0, 1, 3 setzen
        light1.setPosition(new Point3f(0.0f,1.0f,3.0f));
        
        //Einflussvolumen fr Licht setzen
        light1.setInfluencingBounds(new BoundingSphere());
        
        //Licht an Wurzel hngen
        objRoot.addChild(light1);
        //Wurzelknoten (BranchGroup) zurckgeben
        return objRoot;
        
    } 
    // end of createSceneGraph method 
    private void initComponents() {

        setTitle("Java 3D Test");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(400, 300));
        setLocation((screenSize.width-400)/2,(screenSize.height-300)/2);
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }
    
   
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new BookFrame().show();
    }    
}
