/*
 * CloseBehavior.java
 *
 * Created on 10. Mai 2003, 15:26
 */

package j3d_uebung.behavior;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;
/**
 *
 * @author  Tobias
 */
public class CloseBehavior extends Behavior {
    private TransformGroup  targetTG;
    private WakeupCriterion pairPostCondition;
    private WakeupCriterion wakeupNextFrame;
    private WakeupCriterion AWTEventCondition;
    private double buchAngle;
    
    /** Creates a new instance of CloseBehavior */
    CloseBehavior(TransformGroup tg, Behavior Trigger){
        targetTG = tg;
        //Aufwachen:
        AWTEventCondition = new WakeupOnBehaviorPost(Trigger, 7); //Wenn Pick Signal gibt
        wakeupNextFrame = new WakeupOnElapsedTime(1);           //Wenn die Animation luft
    }
    
    public void setBehaviorObjectPartner(Behavior behaviorObject){
        //Behaviorpartner setzen
        //Condition tritt ein, wenn 
        //behaviorObject (OpenBehavior) die ID 1 postet        
        pairPostCondition = new WakeupOnBehaviorPost(behaviorObject, 1);
    }
    
    public void initialize(){
        //Buch zunchst geschlossen
        //Aufwachen, wenn geffnet
        this.wakeupOn(pairPostCondition);
        buchAngle = 0.0;
    }
    
    
    public void processStimulus(Enumeration criteria){
        //Wurde Nachricht vom Behaviorpartner erzeugt?
        if (criteria.nextElement().equals(pairPostCondition)){
            this.wakeupOn(AWTEventCondition);   //Buch wurde geffnet, auf Pick warten
            buchAngle = Math.PI;                   //Buch ist offen
        } else {
            // kann MousePick oder NextFrame sein
            //Ist Buch nicht geschlossen ?
            if (buchAngle > 0.0){
                //Buch weiter schlieen
                buchAngle -= 0.1;
                
                //"Unterlauf" des Schlieungswinkels verhindern
                if (buchAngle < 0.0) buchAngle = 0.0;
                
                // Transformationsdaten der Ziel-Transform-Group holen
                Transform3D t3D = new Transform3D();
                
                //neuen berechneten Winkel setzen (Rotation y-Achse, Winkel negativ)
                t3D.rotY(-buchAngle);
                
                //Transformation setzen
                targetTG.setTransform(t3D);
                
                //Zeitpunkt des nchsten Aufrufes bestimmen
                this.wakeupOn(wakeupNextFrame);
                
            //Buch ist geschlossen    
            } else {
                //das nchste Mal aufwachen,
                //wenn Buch geffnet wurde
                this.wakeupOn(pairPostCondition);
                
                //Bekanntgabe, das Buch geschlossen ist
                postId(2);
            }
        }
    }
    
}
