/*
 * OpenBehavior.java
 *
 * Created on 10. Mai 2003, 15:17
 */

package j3d_uebung.behavior;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;


public class OpenBehavior extends Behavior {
    private TransformGroup  targetTG;
    private WakeupCriterion pairPostCondition;
    private WakeupCriterion wakeupNext;
    private WakeupCriterion AWTEventCondition;
    //ffnungswinkel des Buches
    private double          buchAngle;
    
    
    public OpenBehavior(TransformGroup tg, Behavior Trigger) {
        //Ziel-Transformgruppe
        targetTG = tg;
        
        //Aufwachen:
        AWTEventCondition = new WakeupOnBehaviorPost(Trigger, 7); //Wenn Pick Signal gibt
        wakeupNext = new WakeupOnElapsedTime(1);           //Wenn die Animation luft
    }
    
    public void setBehaviorObjectPartner(Behavior behaviorObject){
        //Behaviorpartner setzen
        //Condition tritt ein, wenn 
        //behaviorObject (CloseBehavior) die ID 2 postet
        pairPostCondition = new WakeupOnBehaviorPost(behaviorObject, 2);
    }
    
    public void initialize(){
        //Aufwachen, wenn PickBehavior Signal gibt
        this.wakeupOn(AWTEventCondition);
        
        //ffnungswinkel des Buches ist anfangs 0
        buchAngle = 0.0;
    }
    
    public void processStimulus(Enumeration criteria){
        //Wurde Nachricht vom Behaviorpartner erzeugt?
        if (criteria.nextElement().equals(pairPostCondition)){  //Wenn Schliessen fertig ist, auf Pick warten
            this.wakeupOn(AWTEventCondition);
            buchAngle = 0.0f;
        } else { // kann MousePick oder NextFrame sein
            //Buch nicht offen?
            if (buchAngle < (float)Math.PI){
                //Buch weiter ffnen
                buchAngle += 0.1;
                //Wenn ffnungswinkel grer als Maximaler Winkel, zurck auf max. Winkel setzen
                if (buchAngle > (float)Math.PI) buchAngle = (float)Math.PI;
                //neue Transformation fr ffnungswinkel
                Transform3D t3D = new Transform3D();
                //ffnungswinkel setzen (Rotation um Y, Winkel negativ)
                t3D.rotY(-buchAngle);
                //neue Transformation setzen
                targetTG.setTransform(t3D);       
                //nach Zeit nchste Animation
                this.wakeupOn(wakeupNext);
            } else { 
                //Nchstes mal Aufwachen, wenn Buch geschlossen
                this.wakeupOn(pairPostCondition);
                //anderes Behavior benachrichtigen
                postId(1);
            }
        }
    }
    
}
