/*
 * BookPickBehavior.java
 *
 * Created on 8. Mai 2003, 15:48
 */

package j3d_uebung.behavior;
import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.media.j3d.Appearance;
import java.awt.Color;

import java.awt.event.MouseEvent;
/**
 *
 * @author  arnd
 */
public class PickBehavior extends Behavior {
    private WakeupCriterion awtEventCondition;
    private PickCanvas pickCanvas;
    private Box object;
    
    /** Creates a new instance of BookPickBehavior */
    public PickBehavior(Canvas3D canvas, BranchGroup root, Box object, TransformGroup targetTG) {

        this.object = object;
        
        //Aufwachkriterium auf Mausklick setzen
        awtEventCondition = new WakeupOnAWTEvent(java.awt.event.MouseEvent.MOUSE_CLICKED);
        
        //PickCanvas mit Canvas und Root-BranchGroup erzeugem
        pickCanvas = new PickCanvas(canvas, root);
        //PickCanvas auf BOUNDS-Modus setzen
        pickCanvas.setMode(PickTool.BOUNDS);
        //Punktgenaues Picking setzen (keine Toleranz)
        pickCanvas.setTolerance(0.0f);
       
        //neues OpenBehavior erzeugen 
        OpenBehavior open = new OpenBehavior(targetTG, this);
        
        //neues CloseBehavior erzeugen
        CloseBehavior close = new CloseBehavior(targetTG, this);
        
        //Behaviorpartner fr Open- und CloseBehavior setzen
        open.setBehaviorObjectPartner(close);
        close.setBehaviorObjectPartner(open);
        
        //Scheduling Bounds fr alle 3 Behaviors setzen
        this.setSchedulingBounds(new BoundingSphere());        
        open.setSchedulingBounds(this.getSchedulingBounds());
        close.setSchedulingBounds(this.getSchedulingBounds());
        
        //neue Behaviors zum ffnen, Schlieen zur Wurzelgruppe hinzufgen
        root.addChild(open);
        root.addChild(close);
    }
    
    public void initialize() {
        //Aufwachkriterium setzen
        this.wakeupOn(awtEventCondition);

    }
  
    public void processStimulus(java.util.Enumeration enumeration) {
        //Kriterium erfllt?
        if (awtEventCondition.hasTriggered()) {
            //angeklicktes Objekt holen
            WakeupOnAWTEvent cond = (WakeupOnAWTEvent)enumeration.nextElement();
            MouseEvent me = (MouseEvent)cond.getAWTEvent()[0];
            pickCanvas.setShapeLocation(me);
            PickResult result = pickCanvas.pickClosest();
            
            //Wenn Objekt Vorder- oder Rckseite des Frontcovers war, Open- und CloseBehavior benachrichtigen
            if ((result!=null)&&((object.getShape(Box.FRONT) == result.getObject())||(object.getShape(Box.BACK) == result.getObject()))) {
                this.postId(7);
            }

        }
        
        //Beim nchsten Klick wieder aufwachen
        this.wakeupOn(awtEventCondition);
    }
}
